#include "aabb.h"
#include "mathvector.h"
#include "unittest.h"

QT_TEST(aabb_test)
{
	AABB <float> box1;
	AABB <float> box2;
	
	MATHVECTOR <float, 3> c1;
	MATHVECTOR <float, 3> c2;
	
	c1.Set(-1,-1,-1);
	c2.Set(1,1,1);
	box1.SetFromCorners(c1, c2);
	
	c1.Set(-0.01, -0.01, 0);
	c2.Set(0.01,0.01, 2);
	box2.SetFromCorners(c1, c2);
	
	QT_CHECK(box1.IntersectAABB(box2));
	
	AABB <float> box3;
	c1.Set(-0.01, -0.01, 2);
	c2.Set(0.01,0.01, 3);
	box3.SetFromCorners(c1, c2);
	
	QT_CHECK(!box1.IntersectAABB(box3));
	
	MATHVECTOR <float, 3> orig;
	MATHVECTOR <float, 3> dir;
	orig.Set(0,0,4);
	dir.Set(0,0,-1);
	
	//QT_CHECK(box1.IntersectRay(orig,dir));
	//QT_CHECK(!box1.IntersectRay(orig,dir*-1));
	
	QT_CHECK(box1.IntersectSegment(orig,dir,4));
	QT_CHECK(!box1.IntersectSegment(orig,dir*-1,4));
	QT_CHECK(!box1.IntersectSegment(orig,dir,1));
}
